Index: client_app/src/components/data/components/user_profile.js
===================================================================
--- client_app/src/components/data/components/user_profile.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
+++ client_app/src/components/data/components/user_profile.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
@@ -0,0 +1,7 @@
+import React from 'react';
+
+const UserDetails = (props) =>{
+    return(
+        
+    );
+}
Index: client_app/src/components/data/profile.js
===================================================================
--- client_app/src/components/data/profile.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
+++ client_app/src/components/data/profile.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
@@ -0,0 +1,20 @@
+import React from 'react';
+import {useHistory} from 'react-router-dom';
+import {render} from "@testing-library/react";
+
+const Profile = (props) => {
+    const history = useHistory();
+    const userProfile = React.useState({
+        userProfile: props.userProfile
+    });
+
+    if(props.userProfile.email==null){
+        history.push("/");
+    }
+
+    return(
+        <h1>?</h1>
+    );
+}
+
+export default Profile;
Index: client_app/src/components/login/login.js
===================================================================
--- client_app/src/components/login/login.js	(revision 1397178abda30e5985bda70c9e7f0380af5ce88e)
+++ client_app/src/components/login/login.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
@@ -4,10 +4,9 @@
 
 const Login = (props) => {
-
     const history = useHistory();
     const [formData, updateFormData] = React.useState({
-        username: "",
+        email: "",
         password: "",
-        type: ""
+        type: "0"
     })
 
@@ -21,9 +20,9 @@
     const onFormSubmit = (e) =>{
         e.preventDefault();
-        const username = formData.username;
+        const email = formData.email;
         const password = formData.password;
         const type = formData.type;
 
-        props.onCompleteForm(username,password,type);
+        props.onCompleteForm(email,password,type);
         history.push("/");
     }
@@ -32,5 +31,5 @@
         <Container>
             <Form onSubmit={onFormSubmit}>
-                <Form.Input id="username" name="username" type='text' required fluid label='E-mail' placeholder='Enter e-mail.' onChange={handleCheck} />
+                <Form.Input id="email" name="email" type='text' required fluid label='E-mail' placeholder='Enter e-mail.' onChange={handleCheck} />
                 <Form.Input id="password" name="password" type='password' required fluid label='Password' placeholder='Enter password.' onChange={handleCheck} />
                 <Form.Field
@@ -39,6 +38,6 @@
                     label='User'
                     id="0"
-                    name='type'
-                    value='0'
+                    name="type"
+                    value="0"
                     checked={formData.type === "0"}
                     onChange={handleCheck}
@@ -49,6 +48,6 @@
                     label='Team'
                     id="1"
-                    name='type'
-                    value='1'
+                    name="type"
+                    value="1"
                     checked={formData.type === "1"}
                     onChange={handleCheck}
@@ -59,6 +58,6 @@
                     label='Company'
                     id="2"
-                    name='type'
-                    value='2'
+                    name="type"
+                    value="2"
                     checked={formData.type === "2"}
                     onChange={handleCheck}
Index: client_app/src/components/main/App.js
===================================================================
--- client_app/src/components/main/App.js	(revision 1397178abda30e5985bda70c9e7f0380af5ce88e)
+++ client_app/src/components/main/App.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
@@ -2,4 +2,5 @@
 import {BrowserRouter as Router, Route} from 'react-router-dom';
 import Login from '../login/login';
+import Profile from "../data/profile";
 import 'semantic-ui-css/semantic.min.css';
 import HeaderComp from '../template/header';
@@ -11,8 +12,5 @@
     super(props);
     this.state = {
-      id: null,
-      email: null,
-      name: null,
-      type: null
+      currentUser: {}
     }
   }
@@ -21,7 +19,8 @@
       return(
           <Router>
-              <HeaderComp acc={this.state.email} accType={this.state.type} name={this.state.name}/>
+              <HeaderComp acc={this.state.currentUser.email} accType={this.state.currentUser.type} name={this.state.currentUser.name}/>
               <main>
                   <Route path={"/login"} render={() => <Login onCompleteForm={this.attemptLogin}/>}/>
+                  <Route path={"/profile"} render={() => <Profile userProfile={this.state.currentUser}/>}/>
                   <Route path={"/"}/>
                   <Route path={"/jobs"}/>
@@ -32,12 +31,10 @@
   }
 
-  attemptLogin = (username, password, type) => {
-      UserLogin.login(username, password, type).then((res) =>{
+  attemptLogin = (email, password, type) => {
+
+      UserLogin.login(email, password, type).then((res) =>{
           console.log(res.data);
           this.setState({
-            id: res.data.id,
-            email: res.data.email,
-            name: res.data.name,
-            type: res.data.type
+              currentUser: res.data
           });
       });
Index: client_app/src/components/template/header.js
===================================================================
--- client_app/src/components/template/header.js	(revision 1397178abda30e5985bda70c9e7f0380af5ce88e)
+++ client_app/src/components/template/header.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
@@ -31,6 +31,12 @@
             return(
                 <Menu inverted position="right">
-                    <Menu.Item as={Link} to='/login'>
-                        Team
+                    <Menu.Item as={Link} to='/profile'>
+                        Profile
+                    </Menu.Item>
+                    <Menu.Item as={Link} to='/jobs'>
+                        Jobs
+                    </Menu.Item>
+                    <Menu.Item as={Link} to='/projects'>
+                        Projects
                     </Menu.Item>
                 </Menu>
@@ -39,6 +45,12 @@
             return(
                 <Menu inverted position="right">
-                    <Menu.Item as={Link} to='/login'>
-                        User
+                    <Menu.Item as={Link} to='/profile'>
+                        Profile
+                    </Menu.Item>
+                    <Menu.Item as={Link} to='/jobs'>
+                        Jobs
+                    </Menu.Item>
+                    <Menu.Item as={Link} to='/internships'>
+                        Internships
                     </Menu.Item>
                 </Menu>
Index: client_app/src/repository/login_repo.js
===================================================================
--- client_app/src/repository/login_repo.js	(revision 1397178abda30e5985bda70c9e7f0380af5ce88e)
+++ client_app/src/repository/login_repo.js	(revision 17abe5eb95d30a27747b54273b41e7dbfc9e3c94)
@@ -2,7 +2,7 @@
 
 const UserLogin = {
-    login: (username, password, type) => {
+    login: (email, password, type) => {
         return axios.post("/login", {
-            "account": username,
+            "email": email,
             "password": password,
             "type": type