Index: client_app/src/components/main/App.js
===================================================================
--- client_app/src/components/main/App.js	(revision 351c43f2a6868f9b3a1e8bd8b24a5f4230e3e687)
+++ client_app/src/components/main/App.js	(revision 19ad8438d36055d2223a068f935053a202359040)
@@ -15,4 +15,5 @@
 import CompanyInternships from "../work/company_internships";
 import UserRegister from "../../repository/register_repo";
+import RegisterUser from "../register/register_user_form";
 
 class App extends Component{
@@ -32,17 +33,14 @@
                   <HeaderComp acc={this.state.currentUser.email} accType={this.state.currentUser.type} name={this.state.currentUser.name} removeState={this.removeState}/>
                   <main>
-                      <Route path={"/login"} render={() => <Login error={this.state.error} onCompleteForm={this.attemptLogin} loggedIn={this.state.logged}/>} />
-                      <Route path={"/profile"} render={() => <Profile userProfile={this.state.currentUser}/>} />
-                      <Route path={"/user/jobs"} render={() => <UserJobs userProfile={this.state.currentUser}/>} />
-                      <Route path={"/user/internships"} render={() => <UserInternships userProfile={this.state.currentUser}/>} />
-                      <Route path={"/user/projects"} render={() => <UserProjects userProfile={this.state.currentUser}/>} />
-                      <Route path={"/team/jobs"} render={() => <TeamJobs userProfile={this.state.currentUser} />}/>
-                      <Route path={"/team/projects"} render={() => <TeamProjects userProfile={this.state.currentUser} />}/>
-                      <Route path={"/company/jobs"} render={() => <CompanyJobs userProfile={this.state.currentUser} />}/>
-                      <Route path={"/company/internships"} render={() => <CompanyInternships userProfile={this.state.currentUser}/>} />
-                      <Route path={"/profile/edit"} />
-                      <Route path={"/job/edit"} />
-                      <Route path={"/internship/edit"}/>
-                      <Route path={"/project/edit"} />
+                      <Route path={"/login"} render={() => <Login error={this.state.error} onCompleteForm={this.attemptLogin} loggedIn={this.state.logged}/>}/>
+                      <Route path={"/profile"} render={() => <Profile userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/user/jobs"} render={() => <UserJobs userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/user/internships"} render={() => <UserInternships userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/user/projects"} render={() => <UserProjects userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/team/jobs"} render={() => <TeamJobs userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/team/projects"} render={() => <TeamProjects userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/company/jobs"} render={() => <CompanyJobs userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/company/internships"} render={() => <CompanyInternships userProfile={this.state.currentUser}/>}/>
+                      <Route path={"/register/user"} render={() => <RegisterUser error={null}/>}/>
                       <Route path={"/logout"} render={() => <Redirect to={"/login"}/>}/>
                       <Route path={"/"} render={() => <Redirect to={"/login"}/>}/>
@@ -78,10 +76,4 @@
       });
 
-
-
-      registerUser = () =>{
-          UserRegister.userRegister()
-      }
-
       if(this.state.currentUser.email!=null){
           return <Redirect to={"/profile"}/>;
Index: client_app/src/components/register/register_user_form.js
===================================================================
--- client_app/src/components/register/register_user_form.js	(revision 351c43f2a6868f9b3a1e8bd8b24a5f4230e3e687)
+++ client_app/src/components/register/register_user_form.js	(revision 19ad8438d36055d2223a068f935053a202359040)
@@ -1,7 +1,9 @@
 import React from 'react';
-import { Button, Checkbox, Container, Form } from "semantic-ui-react";
+import 'semantic-ui-react';
+import {Button, Container, Form} from "semantic-ui-react";
 import { Redirect } from 'react-router-dom';
 import SkillFetch from "../../repository/skill_repo";
 import UserRegister from "../../repository/register_repo";
+import {Component} from "react/cjs/react.production.min";
 
 class RegisterUser extends Component {
@@ -21,4 +23,11 @@
     }
 
+    handleCheck = (e, {value}) => {
+        this.setState({
+            ...this.state,
+            [e.target.name]: value
+        })
+    }
+
     render() {
         return (
@@ -27,8 +36,17 @@
                 <Form onSubmit={this.attemptRegister}>
                     <Form.Input id="email" name="email" type='email' required fluid label='E-mail'
-                                placeholder='Enter e-mail.' onChange={handleCheck}/>
+                                placeholder='Enter e-mail.' onChange={this.handleCheck}/>
                     <Form.Input id="password" name="password" type='password' required fluid label='Password'
-                                placeholder='Enter password.' onChange={handleCheck}/>
-                                
+                                placeholder='Enter password.' onChange={this.handleCheck}/>
+                    <Form.Input id="name" name="name" type='text' required fluid label='Name'
+                                placeholder='Enter name.' onChange={this.handleCheck}/>
+                    <Form.Input id="surname" name="surname" type='text' required fluid label='Surname'
+                                placeholder='Enter surname.' onChange={this.handleCheck}/>
+                                <label>Skills you know:</label>
+                    <select multiple="" class="ui dropdown">
+                        {this.state.allSkills.map(item => {
+                            return <option value={item.id}>{item.name}</option>
+                        })}
+                    </select>
                     <Button type="submit">Register</Button>
                 </Form>
@@ -40,5 +58,5 @@
         SkillFetch.fetchAll().then((data) =>{
             this.setState({
-                allSkills: data
+                allSkills: data.data
             })
         })